diff --git a/libr/core/cmd_search.c b/libr/core/cmd_search.c
index b5e6f1f0b0920..47eb47240de28 100644
--- a/libr/core/cmd_search.c
+++ b/libr/core/cmd_search.c
@@ -274,9 +274,6 @@ static int __cb_hit(RSearchKeyword *kw, void *user, ut64 addr) {
 		}
 	}
 
-	if (core->section && (core->section->rwx & R_IO_MAP))
-		base_addr = core->section->offset;
-
 	if (searchshow && kw && kw->keyword_length > 0) {
 		int len, i, extra, mallocsize;
 		ut32 buf_sz = kw->keyword_length;
diff --git a/libr/include/r_io.h b/libr/include/r_io.h
index 387f6eb312481..d32af33e7ce0a 100644
--- a/libr/include/r_io.h
+++ b/libr/include/r_io.h
@@ -386,6 +386,7 @@ R_API RIOSection *r_io_section_get_name(RIO *io, const char *name);
 R_API RIOSection *r_io_section_get_i(RIO *io, int idx);
 R_API RIOSection *r_io_section_getv(RIO *io, ut64 vaddr);
 R_API RIOSection *r_io_section_mget(RIO *io, ut64 maddr);
+R_API RIOSection *r_io_section_mget_prev(RIO *io, ut64 maddr);
 R_API RIOSection *r_io_section_vget(RIO *io, ut64 addr);
 R_API RIOSection *r_io_section_pget(RIO *io, ut64 addr);
 R_API int r_io_section_set_archbits(RIO *io, ut64 addr, const char *arch, int bits);
diff --git a/libr/io/io.c b/libr/io/io.c
index 0ab7e259fbda3..140e06d586452 100644
--- a/libr/io/io.c
+++ b/libr/io/io.c
@@ -340,7 +340,11 @@ R_API int r_io_read(RIO *io, ut8 *buf, int len) {
 	if (io->enforce_rwx & R_IO_READ)
 		if (!(r_io_section_get_rwx (io, io->off) & R_IO_READ))
 			return -1;
-	ret = r_io_read_at (io, io->off, buf, len);
+	/* io->off is in maddr, but r_io_read_at works in vaddr
+	 * FIXME: in some cases, r_io_seek sets io->off in vaddr */
+	ut64 vaddr = r_io_section_maddr_to_vaddr(io, io->off);
+	vaddr = (vaddr == UT64_MAX) ? io->off : vaddr;
+	ret = r_io_read_at (io, vaddr, buf, len);
 	if (ret > 0) io->off += ret;
 	return ret;
 }
diff --git a/libr/io/section.c b/libr/io/section.c
index 36bf45b2cc32c..0a486af3a6cb8 100644
--- a/libr/io/section.c
+++ b/libr/io/section.c
@@ -274,6 +274,16 @@ R_API RIOSection *r_io_section_mget(RIO *io, ut64 maddr) {
 	return NULL;
 }
 
+R_API RIOSection *r_io_section_mget_prev(RIO *io, ut64 maddr) {
+	RIOSection *s;
+	RListIter *iter;
+	r_list_foreach_prev (io->sections, iter, s) {
+		if ((maddr >= s->offset && maddr < (s->offset + s->size)))
+			return s;
+	}
+	return NULL;
+}
+
 // XXX: rename this
 R_API ut64 r_io_section_get_offset(RIO *io, ut64 maddr) {
 	RIOSection *s = r_io_section_mget (io, maddr);
@@ -338,7 +348,9 @@ R_API ut64 r_io_section_vaddr_to_maddr(RIO *io, ut64 vaddr) {
 /* returns the conversion from file offset to vaddr if the given offset is
  * mapped somewhere, UT64_MAX otherwise */
 R_API ut64 r_io_section_maddr_to_vaddr(RIO *io, ut64 offset) {
-	RIOSection *s = r_io_section_mget (io, offset);
+	/* Use reverse iterator, since sections that are at the
+	 * end of the list are usually the bigger ones */
+	RIOSection *s = r_io_section_mget_prev (io, offset);
 	if (s) {
 		io->section = s;
 		return (s->vaddr + offset - s->offset);
